package com.propertyManagement.business.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.propertyManagement.common.utils.StringUtils;
import com.propertyManagement.common.core.page.TableDataInfo;
import com.propertyManagement.common.core.domain.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import com.propertyManagement.business.domain.bo.WxSlideshowBo;
import com.propertyManagement.business.domain.vo.WxSlideshowVo;
import com.propertyManagement.business.domain.WxSlideshow;
import com.propertyManagement.business.mapper.WxSlideshowMapper;
import com.propertyManagement.business.service.IWxSlideshowService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 轮播图
Service业务层处理
 *
 * @author liushuai
 * @date 2025-06-09
 */
@RequiredArgsConstructor
@Service
public class WxSlideshowServiceImpl implements IWxSlideshowService {

    private final WxSlideshowMapper baseMapper;

    /**
     * 查询轮播图

     */
    @Override
    public WxSlideshowVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 查询轮播图
列表
     */
    @Override
    public TableDataInfo<WxSlideshowVo> queryPageList(WxSlideshowBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<WxSlideshow> lqw = buildQueryWrapper(bo);
        Page<WxSlideshowVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询轮播图
列表
     */
    @Override
    public List<WxSlideshowVo> queryList(WxSlideshowBo bo) {
        LambdaQueryWrapper<WxSlideshow> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<WxSlideshow> buildQueryWrapper(WxSlideshowBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<WxSlideshow> lqw = Wrappers.lambdaQuery();
        lqw.eq(StringUtils.isNotBlank(bo.getUrl()), WxSlideshow::getUrl, bo.getUrl());
        lqw.eq(bo.getIsEnable() != null, WxSlideshow::getIsEnable, bo.getIsEnable());
        return lqw;
    }

    /**
     * 新增轮播图

     */
    @Override
    public Boolean insertByBo(WxSlideshowBo bo) {
        WxSlideshow add = BeanUtil.toBean(bo, WxSlideshow.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改轮播图

     */
    @Override
    public Boolean updateByBo(WxSlideshowBo bo) {
        WxSlideshow update = BeanUtil.toBean(bo, WxSlideshow.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(WxSlideshow entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 批量删除轮播图

     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteBatchIds(ids) > 0;
    }
}
